import { marked } from 'marked';
import type { Post } from '@blog/Model/Post';
import * as yamlFront from 'yaml-front-matter';

export async function readPostMarkdown(filename: string): Promise<Post> {
  const file = Bun.file(filename);
  const contents = await file.text();

  const parsedData = yamlFront.loadFront(contents);
  const parsedPost = await marked.parse(parsedData.__content);

  return {
    title: parsedData.title,
    slug: filename.slice(0, -3),
    description: parsedData.description,
    date: new Date(parsedData.date),
    tags: parsedData.tags,
    content: parsedPost 
  };
}

